$INTERFACE U2FDU3                                             97/12/01
$REM VL

  $N='N'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,0,INT,2)
  $MA=MB
  $IF(MA<=0) $MA='$NF+3'
  $ADD(INIT)
    MA=$MA
  $ENDADD
  $IF(NA=0)
    $MAL=MA
  $ELSE
    $MAL=NA
  $ENDIF
  $TYPE='L'
  $SUBP='Q'
  $DECOMP='Q'
  $NUMBER=1
  $IF(SUBP='Q')
    $HELP
      QUADRATIC PROGRAMMING METHOD:
        1 - DUAL QUADRATIC PROGRAMMING METHOD
        2 - PRIMAL QUADRATIC PROGRAMMING METHOD
    $CHECK(NUMBER,'1','1\2',2,NO)
    $IF(NUMBER=2)
      $ADD(REAL,'\$AFO($MA)')
    $ENDIF
  $ENDIF
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $STEP=5
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ETA5='0.0$P 0'
  $ENDIF
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'1.0D-4',REAL,4)
  $HELP
    MEASURE OF NONCONVEXITY
  $CHECK(ETA5,'0.25$P 0',REAL,3)
  $IRES1=111
  $IRES2=999
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,20,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
  $CHECK(MTESF, 7,INT,4)
  $ADD(INIT)
    ISNA=0
  $ENDADD
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  N=NF
  $IF(NAL>0)
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
    $IF(NORMF>0) $SUBST('UATRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $SN=S
    $GN=GO
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='S')
    $SUBST('UYFP$(CONSTR)1')
  $ELSEIF(CONSTR='B')
    $ICA=IAA
    $CZ=AZ
    $CR=AR
    $SUBST('UYFP$(CONSTR)2')
  $ENDIF
*
*     --------------------
*     BUNDLE-NEWTON METHOD
*     TEMPLATE : U2FDU3
*     --------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  MAL=0
  MA=$MA
  $IF (MB=0)
    MA=NF+3
  $ENDIF
  GMAX=ETA9
$L=$10 ; $LABEL
  $KD=2
  $GOS=GO
  $GO=SO
  $SUBST('UZMODN')
  $GO=GOS
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  N=NF
  UMAX=ZERO
  $SUBST('UO2FU3')
  $AFH=AF ; $IF(MODEL='A?') $AF='AFF'
  $IAH=IA ; $IF(MODEL='A?') $IA='IAF'
  $ADD(SINID)
    CALL UXVSET(NF,ZERO,$S)
    CALL UXVSET(5*MA,ZERO,$AF)
  $ENDADD
  $SUBST('UYFUT4')
  IF (ITERM.NE.0) GO TO $90
$L=$ 40 ; $LABEL
  $GH=G ; $G=GO
  $SUBST('UUDSD1')
  IF (ITERQ.EQ.3) CALL UOERR1(NQPX,102)
  IF (ITERM.NE.0) GO TO $90
  N=NF
  $MZ=MAL
  $MAL=MA
  $IF(NUMBER=2) CALL UXVCOP(MAL,$AF,$AFO)
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDDB$(SUBP)2
*     -----------------------
*
  $SUBST('UDDB$(SUBP)2')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(NUMBER=2) CALL UXVCOP(MAL,$AFO,$AF)
  $MAL=MZ
  $IF(TYPE='L')
    $SUBST('UD1TL2')
  $ELSE
    $SUBST('UD1TG2')
    $IF(SUBP='Q')
      PP=XNORM-F-HALF*P
    $ELSE
      PP=XNORM-F
    $ENDIF
  $ENDIF
  IF (SNORM.LE.ZERO) THEN
  TXFU='ZERO DIR'
  ITERM=4
  ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTRUS')
  $IF(TYPE='L') PP=UXVDOT(NF,$GH,$S)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $G=GH
  $IF(TYPE='L')
    RMIN=1.0$P-3
    TO=ONE
  $ENDIF
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 64 ; $LABEL
  ITERD=0
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  ELSE
  TXFU=TUXX
  $BUNDLE=1
  $SUBST('UYTRXD')
  $IF(CONSTR='B')
    $SUBST('UCLNF2')
  $ENDIF
  ENDIF
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $AF=AFH
  $IA=IAH
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL1')
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2FDU3'
  $ENDADD
  $EXIT
