$INTERFACE U2SBU1                                             97/12/01
$REM LU
  $N='NF'
  $ADD(INTEGER,'\IMD\METS')
  $HH='HH'
  $HERF='B'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $DECOMP='M'
  $IF(TYPE='L')
    $NUMBER=3
    $DEFAULT=0
    $IF(KDA>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
          2 - FIRST DIRECTIONAL DERIVATIVES
              (WITH COMPUTED HESSIAN MATRICES)
      $CHECK(KDS,$DEFAULT,'0\1\2',4,NO)
      $IF(KDA>1) $KDS=1
    $ELSE
      $KDS=0
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,-2,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
    $LCS=0
  $ELSE
    $HELP
       METHOD
         3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
         4 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
             WITH THE LANCZOS STEPS
         5 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
             WITH THE LANCZOS STEPS
    $CHECK(NUMBER,3,'3\4\5',2,NO)
    $ISTEP=0
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
    $DEFAULT=0
    $IF(KDA>0) $DEFAULT=2
    $IF($DEF(FMODELA)) $DEFAULT=0
    $IF(DEFAULT=2)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
          2 - FIRST DIRECTIONAL DERIVATIVES
              (WITH COMPUTED HESSIAN MATRICES)
      $CHECK(KDS,$DEFAULT,'0\1\2',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
    $LCS=1
  $ENDIF
  $ADD(INIT)
    LCS=$LCS
  $ENDADD
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2',4)
  $IF(KDA>1)
    $UPDATE='NO'
  $ELSE
    $IF(MODEL='AQ')
      $HELP
        TYPE OF UPDATE
          B - SIMPLE CORRECTION OF THE GAUSS-NEWTON MATRIX
          F - FLETCHER'S HYBRID UPDATE
          D - CORRECTION OF THE HESSIAN MATRICES
          S - CORRECTION OF THE SECOND DERIVATIVE TERM
          N - NO UPDATE
      $CHECK(UPDATE,'N','B\F\D\S\NO\N',3,NO)
      $IF(UPDATE='N') $UPDATE='NO'
    $ELSE
      $HELP
        TYPE OF UPDATE
          B - SIMPLE CORRECTION OF THE GAUSS-NEWTON MATRIX
          F - FLETCHER'S HYBRID UPDATE
          N - NO UPDATE
      $CHECK(UPDATE,'N','B\F\NO\N',3,NO)
      $IF(UPDATE='N') $UPDATE='NO'
    $ENDIF
    $DEFAULT=4
    $IF(UPDATE='F') $DEFAULT=1
    $IF(UPDATE<>'NO')
      $HELP
        UPDATE OF THE HESSIAN MATRIX:
          1 - BFGS UPDATE
          2 - DFP  UPDATE
          3 - HOSHINO UPDATE
          4 - RANK ONE UPDATE
      $CHECK(MET,DEFAULT,'0\1\2\3\4',3)
      $IF(UPDATE='B')
        $HELP
          RESTART OF VARIABLE METRIC METHODS:
            1 - SIMPLE UPDATE
            2 - CUMMULATIVE UPDATE
        $CHECK(MET5,2,'1\2',4)
        $IF(MET5=2)
          $IF(KDS=2) $KDS=1
        $ENDIF
        $IF(MET=4) $MET1=1
        $DEFAULT=4
        $IF(MET5=2) $DEFAULT=2
        $HELP
          SELECTION OF SELF SCALING:
            1 - SELF SCALING SUPPRESSED
            2 - INITIAL SELF SCALING
            3 - CONTROLLED SELF SCALING
            4 - SELF SCALING IN EACH ITERATION
        $CHECK(MET1,DEFAULT,'1\2\3\4',4)
        $DEFAULT='1.5D-4'
        $IF(TYPE='L') $DEFAULT='5.0D-3'
        $HELP
          TOLERANCE FOR APPLICATION OF THE BFGS METHOD
        $CHECK(ETA5,DEFAULT,REAL,4)
      $ELSEIF(UPDATE='F')
        $HELP
          RESTART OF VARIABLE METRIC METHODS:
            1 - SIMPLE UPDATE
            2 - CUMMULATIVE UPDATE
        $CHECK(MET5,2,'1\2',4)
      $ENDIF
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ENDIF
  $ENDIF
  $HELP
    CHOICE OF THE SCALING MATRIX:
      1 - UNIT MATRIX
      2 - SQUARE OF DIAGONAL OF THE MATRIX H
  $CHECK(MOS1,1,'1\2',4)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
    $IF(ISNA>1)
      $IF(NORMF>0) $SUBST('UATRL3')
    $ENDIF
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPS1')
*
*     -------------------------------
*     PARTITIONED GAUSS-NEWTON METHOD
*     TEMPLATE : U2SBU1
*     -------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(-1)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $KD=2
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $SUBST('UYTB$(CONSTR)H')
  $IF(UPDATE='B')
    $SUBST('UUBSD1')
  $ELSEIF(UPDATE='D')
    $SUBST('UUBSD5')
  $ELSEIF(UPDATE='F')
    $SUBST('UUBSD3')
  $ELSEIF(UPDATE='S')
    $SUBST('UUBSD2')
  $ELSE
    $SUBST('UUBSD1')
  $ENDIF
  IF (ITERM.NE.0) GOTO $80
  $MAT='G'
  $DEC=DECOMP
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DEC)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DEC)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
$REM  $IF(TYPE='T') $TYPE='G'
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $IF(UPDATE='F')
    $IF(MET5=1) $SUBST('UUBSD4')
  $ENDIF
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  $IF(ISNA>1)
    CALL UXVCOP(MA,$AG,$AGO)
  $ENDIF
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$ 52 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 54 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    $IF(TYPE='L')
      $IF(ISNA>1)
        CALL UXVCOP(MA,$AGO,$AG)
      $ENDIF
    $ELSE
      $IF(ISNA>1)
        IF (MOT3.LE.0) CALL UXVCOP(MA,$AGO,$AG)
      $ENDIF
    $ENDIF
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  $IF(UPDATE='B')
    $IF(MET5=2)
    IF (FO-F.LE.ETA5*FO) KD=1
    $ENDIF
  $ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  ITERD=0
  $IF(UPDATE<>'NO')
$REM    $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
    $IF(UPDATE='S')
      $SUBST('UYTA$(CONSTR)B')
      $HS=H
      $H='HH'
      $SUBST('UUBBM2')
      $H=HS
    $ELSEIF(UPDATE='F')
      $SUBST('UYTA$(CONSTR)D')
      $SUBST('UUBF$(DECOMP)1')
    $ELSEIF(UPDATE='B')
      KD=2
      $IHLP=1
      $IF(MET=4) $IHLP=2
      $SUBST('UYTA$(CONSTR)D')
      IF (FO-F.LE.ETA5*FO) THEN
      $IF(TYPE='L')
        $IF(MET1=4)
          CALL UXBSDA(MB,NA,H,IAG,0.05$P 0)
        $ENDIF
      $ENDIF
      $SUBST('UUBB$(DECOMP)$IHLP')
      ENDIF
    $ELSEIF(UPDATE='D')
      $SUBST('UYTA$(CONSTR)D')
      $HS=H
      $H='HH'
      $SUBST('UUBB$(DECOMP)2')
      $H=HS
    $ENDIF
  $ELSE
    $SUBST('UYTRED')
  $ENDIF
$L=$75 ; $LABEL
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADS0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(ISNA>1)
      $IF(NORMF>0) $SUBST('UATRL3')
    $ENDIF
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2SBU1'
  $ENDADD
  $EXIT
