$INTERFACE UA1DQ2                                             98/12/01
  $IF(MODELY='YES') $SUBST('UZYSET')
  $EY='EY'
  $EW='EW'
  $IF(MODELF='NO')
    $GF='G'
    $DF='G'
  $ENDIF
  $MCG=0
  $IF(GRAPH='NO')
    $HELP
      CHOICE OF MESH POINTS
        0 - MESH POINTS UNUSED
        1 - MESH POINTS IN ALL INTEGRATION STEPS
        2 - PRESCRIBED MESH POINTS
    $CHECK(MED,0,'0\1\2',4)
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,1,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=0)
    $NA=1
  $ELSEIF(MED=1)
    $REPEAT
      $HELP
        DECLARED NUMBER OF MESH POINTS
      $CHECK(NA,0,INT,1)
      $IF(NA<=0)
        $IF(DIALOG>0)
          $ERASE(NA)
        $ELSE
          $ERROR: 'NA' - NUMBER OF MESH POINTS WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(NA))
  $ELSEIF(MED=2)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $REPEAT
    $HELP
      INTEGRAL PART OF THE OBJECTIVE FUNCTION
        N - INTEGRAL PART EXCLUDED
        Y - INTEGRAL PART INCLUDED
    $CHECK(MODELA,'N','NO\N\YES\Y',1,NO)
    $IF(MODELA='N') $MODELA='NO'
    $IF(MODELA='Y') $MODELA='YES'
    $HELP
      TERMINAL PART OF THE OBJECTIVE FUNCTION
        N - TERMINAL PART EXCLUDED
        Y - TERMINAL PART INCLUDED
    $CHECK(MODELF,'N','NO\N\YES\Y',1,NO)
    $IF(MODELF='N') $MODELF='NO'
    $IF(MODELF='Y') $MODELF='YES'
    $IF(MODELA='NO')
      $IF(MODELF='NO')
        $IF(DIALOG>0)
          $ERASE(MODELA)
          $ERASE(MODELF)
        $ELSE
          $ERROR: OBJECTIVE FUNCTION WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $ENDIF
  $UNTIL($DEF(MODELA))
  $IF(MODELA='YES')
    $KDA=0
    $ADD(SINIT)
      YE=ZERO
      WE=ONE
    $ENDADD
  $ENDIF
  $IF(MODELF='YES')
    $KDF=0
    $DIME=NE
    $ADD(SINIT)
      CALL UXVSET(NE,ZERO,$EY)
      CALL UXVSET(NE,ONE,$EW)
    $ENDADD
  $ELSE
    $DIME=1
  $ENDIF
  $ADD(INIT)
    KDA=$KDA
    KDF=$KDF
  $ENDADD
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $DEFAULT='DP8'
  $IF(MED=1) $DEFAULT='DP5'
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,DEFAULT,'DP5\DP8',2,NO)
  $MEL='2*$NE+$NF'
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$EY($DIME)\$EW($DIME)&
  \$G($NF)\$GE($NF)')
      $IF(MED=2)
        $ADD(SINID)
          CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
        $ENDADD
      $ENDIF
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDIF
 $00  CALL UA1DQ2(NF,NA,NE,MEL,KA,KE,$AT,$AY,$YA,$EY,$EW,$G,$GE,$ETA9&
,F,TA,TAMAX,HE,MED,MED1,MED2,IER)
      GOTO ($40,$10,$30) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE1DQ2')
      $GO TO $10
 $30  CONTINUE
      $IF(MODELY='YES')
        $IF(LYD<1)
          $IF(GMODY='G')
            $MTYPE=GMODY
            $SUBST('UZYMOD')
          $ENDIF
        $ELSE
          CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
        $ENDIF
      $ENDIF
      $GO TO $00
 $40  CONTINUE
      IF (ITERM.NE.0) CALL UXVSET(NF,ZERO,G)
      $ADD(INIT)
        MEL=$MEL
        NAXX='UA1DQ2'
      $ENDADD
      $EXIT
