$INTERFACE UA2DQ1                                             98/12/01
  $KD=1
  $IF(MODELY='YES') $SUBST('UZYSET')
  $EY='EY'
  $EW='EW'
  $IF(MODELF='NO')
    $GF='G'
    $DF='G'
  $ENDIF
  $MCG=0
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $REPEAT
    $HELP
      INTEGRAL PART OF THE OBJECTIVE FUNCTION
        N - INTEGRAL PART EXCLUDED
        Y - INTEGRAL PART INCLUDED
    $CHECK(MODELA,'N','NO\N\YES\Y',1,NO)
    $IF(MODELA='N') $MODELA='NO'
    $IF(MODELA='Y') $MODELA='YES'
    $HELP
      TERMINAL PART OF THE OBJECTIVE FUNCTION
        N - TERMINAL PART EXCLUDED
        Y - TERMINAL PART INCLUDED
    $CHECK(MODELF,'N','NO\N\YES\Y',1,NO)
    $IF(MODELF='N') $MODELF='NO'
    $IF(MODELF='Y') $MODELF='YES'
    $IF(MODELA='NO')
      $IF(MODELF='NO')
        $IF(DIALOG>0)
          $ERASE(MODELA)
          $ERASE(MODELF)
        $ELSE
          $ERROR: OBJECTIVE FUNCTION WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $ENDIF
  $UNTIL($DEF(MODELA))
  $IF(MODELA='YES')
    $KDA=0
    $ADD(SINIT)
      YE=ZERO
      WE=ONE
    $ENDADD
  $ENDIF
  $IF(MODELF='YES')
    $KDF=0
    $DIME=NE
    $ADD(SINIT)
      CALL UXVSET(NE,ZERO,$EY)
      CALL UXVSET(NE,ONE,$EW)
    $ENDADD
  $ELSE
    $DIME=1
  $ENDIF
  $ADD(INIT)
    KDA=$KDA
    KDF=$KDF
  $ENDADD
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $POM='V'
  $IF(SOLVER='RD5') $POM='D'
  $IF(SOLVER='RS4') $POM='D'
  $IF(MODELA='YES')
    $MEL='($NE*$NF+$NE+$NF+$M+1)'
  $ELSE
    $MEL='($NE*$NF+$NE)'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$EY($DIME)\$EW($DIME)&
  \$G($NF)\$GE($NF)\$H($NF*($NF+1)/2)')
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $LET=$00
      $LED=$30
      $LES=$20
 $00  CALL UA2DQ1(NF,NA,NE,MEL,KE,$AT,$AY,$YA,$EY,$EW,$G,$GE,$H,$ETA9&
,F,FE,TA,HE,MED,MED1,MED2,IER)
      GOTO ($40,$10,$20) ISB+1
 $10  CONTINUE
      $IF(MODELY='YES')
        $IF(LYD<0)
          $MTYPE=FMODY
          $SUBST('UZYMOD')
        $ELSE
          FE=$EF(KE)
          $EF(KE)=ZERO
        $ENDIF
        IF (KD.LE.0) GO TO $00
        $IF(LYD<1)
          $IF(GMODY='G')
            $MTYPE=GMODY
            $SUBST('UZYMOD')
          $ENDIF
        $ELSE
          CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
          CALL UXVSET(NF,ZERO,$EG((KE-1)*NF+1))
        $ENDIF
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $SUBST('UE$POM$SOLVER')
 $30  CONTINUE
$REM      $KD=1
      $SUBST('UE2DQ1')
      $GO TO $20
 $40  CONTINUE
      IF (ITERM.NE.0) CALL UXVSET(NF,ZERO,G)
      $ADD(INIT)
        MEL=$MEL
        NAXX='UA2DQ1'
      $ENDADD
      $EXIT
