$INTERFACE UDSLA1                                             16/12/01
$REM LU
$REM  $POM1='U'
$REM  $POM2=',$$IX,-KBF)'
  $POM1='V'
  $POM2=')'
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $ADD(REAL,'\$H($MMAX)\$G($NF)\$S($NF)\$GO($NF)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\RHO\SIG\TEMP')
  $ADD(INTEGER,'\I\K\L\MM')
  CALL UOD1D1
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  $IF(HESF='D')
    CALL UXDSMC(NF,$H,$HH)
  $ENDIF
  $IHLP='I'
  $IF(FORM='SM') $IHLP='S'
  $SUBST('UDSL$(DECOMD)$IHLP')
  IDECF=0
  INITD=MAX(ABS(INITD),1)
  IF (IDECF.NE.1) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
  $IF(HESF='S')
    MM=$IH(NF+1)-1
    CALL UXSPCT(NF,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $90
    ENDIF
    ALF=ETA2
    CALL UXSPCF(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GO,INF&
,ALF,RHO)
  $ELSEIF(HESF='D')
    ALF=ETA2
    CALL UXDPGF(NF,$HH,INF,ALF,RHO)
  $ENDIF
  NDECF=NDECF+1
  IDECF=1
  ENDIF
*
*     BACK SUBSTITUTIONS
*
  CALL UXVNEG(NF,$G,$S)
  $IF(HESF='S')
  CALL UXVSFP(NF,$PERM,$S,$GO)
  CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
  CALL UXVSBP(NF,$PERM,$S,$GO)
  $ELSEIF(HESF='D')
    CALL UXDPGB(NF,$HH,$S,0)
  $ENDIF
  SNORM=SQRT(UXVDOT(NF,$S,$S))
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  P=UXVDOT(NF,$S,$G)
$REM  CALL UODLX4(NF,NA,$X,$G,$S,$GO,FF,RPF3,INF)
$90 CONTINUE
  R=ZERO
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSLA1'
  $ENDADD
  $EXIT
