$INTERFACE UDVLV7                                             10/12/01
$REM VL
  $XM='XM'
  $GM='GM'
  $XR='XR'
  $GR='GR'
  $RW='RW'
  $IW='IW'
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $POM3='C'
    $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
    $POM3='S'
  $ENDIF
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,5,INT,2)
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,3,'1\2\3\4\5',4)
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,999,INT,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'0.8$P 0',REAL,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XM($NF*$MF)\$GM($NF*$MF)&
\$XR(2*$MF*$MF)\$GR($MF*($MF+1)/2)\$RW(9*$MF)')
  $ADD(INTEGER,'\IW(5*$MF)\I\J\L\MX')
  $ADD(REAL,'\UXVDOT\POM')
  CALL UOD1D1
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) THEN
*
*     STEEPEST DESCENT DIRECTION
*
  MX=0
  CALL UX$(POM1)NEG($N,$GN,$SN$POM2
  SNORM=GNORM
  TUXX='INITIAL '
  TDXX='ST.DESC.'
  CALL UYSET3
  ELSE
*
*     LIMITED MEMORY VARIABLE METRIC DIRECTION
*
  CALL UXLSIV($N,MX,MF,$XR,$GR,$XM,$GM,$GN,$SN,$XR(MF*MF+1),$RW(8*MF+1)&
,$RW,$RW(MF+1),$RW(2*MF+1),B/BB)
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  TUXX='SLVM-   '
  WRITE (TUXX(6:7),'(I2)') MX
  ENDIF
  ITERD=0
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDVLV7'
  $ENDADD
  $EXIT
