$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZGMIN                                     01/12/92 +
$REM + SI                                                            +
$REM + PURPOSE:  SELECTION OF GLOBAL MINIMIZATION METHOD             +
$REM +---------------------------------------------------------------+

$HELP
  CLASS OF METHOD FOR GLOBAL OPTIMIZATION:
    1 - SIMPLE STOCHASTIC METHODS
    2 - HEURISTIC METHODS
    3 - CLUSTERING METHODS
    4 - MULTI LEVEL METHODS
$CHECK(GCLASS,'4','1\2\3\4',2,NO)

$IF (GCLASS=1)

  $HELP
    TYPE OF STOCHASTIC METHOD
      1 - SINGLESTART
      2 - MULTISTART
      3 - MODIFIED MULTISTART
      4 - REDUCED MULTISTART WITH BAYESIAN
          STOPPING RULE
  $CHECK(GTYPE,'4','1\2\3\4',2,NO)

$ELSEIF (GCLASS=2)

  $HELP
    TYPE OF HEURISTIC METHOD
      1 - TUNNELING METHOD
      2 - COMBINED TUNNELING
          AND RANDOM START METHOD
      3 - FILLED FUNCTION METHOD
  $CHECK(GTYPE,'2','1\2\3',2,NO)

$ELSEIF (GCLASS=3)

  $HELP
    TYPE OF CLUSTERING METHOD
      1 - DENSITY CLUSTERING METHOD
      2 - SINGLE LINKAGE METHOD
  $CHECK(GTYPE,'2','1\2',2,NO)

$ELSEIF (GCLASS=4)

  $HELP
    TYPE OF MULTI LEVEL METHOD
      1 - MULTI LEVEL SINGLE LINKAGE
      2 - MULTI LEVEL MODE ANALYSIS
      3 - MODIFIED MULTI LEVEL SINGLE LINKAGE
  $CHECK(GTYPE,'3','1\2\3',2,NO)

$ENDIF

$XL='XL'
$XU='XU'
$REM $ADD(INTEGER,'\IER')
$ADD(SINIT)
  CALL UXVSET(NF,ZERO,XL)
  CALL UXVSET(NF,ZERO,XU)
$ENDADD
$REM IER=0
$RECURSIVE='YES'
$SUBST('UOGFG1')
$SUBST('UYGSET')
$SUBST('UGFU$GCLASS$GTYPE')
  $IF(DISPLAY='YES')
    $SUBST('UOGFG2')
  $ELSEIF(GRAPH='INTERNAL')
    $SUBST('UOGFG2')
  $ELSEIF(GRAPH='EXTERNAL')
    $SUBST('UOGFG3')
  $ENDIF
